<?php
/*
Plugin Name: GMail Player Widget
Plugin URI: http://nothing.golddave.com/?page_id=70
Description: Adds a sidebar widget to let users play a designated audio file with the GMail player.
Author: David Goldstein
Version: 1.03
Author URI: http://nothing.golddave.com/
*/

/*
Version History:
1.03 - Autoplay is now working
1.02 - Changed player implementation from iframe to object
			 Changed instantiation of player from plugin to external script (gmailplayer.js) to accomodate EOLAS changes in IE
1.01 - Added basic non widget functionality
1.0 - Initial public release
*/

function widget_gplayer_init() {
	if ( !function_exists('register_sidebar_widget') )
		return;
	
	function widget_gplayer($args) {
		extract($args);
		$options = get_option('widget_gplayer');
		$title = empty($options['title']) ? __('GMail Player') : $options['title'];
		$audiourl = empty($options['audiourl']) ? __('') : $options['audiourl'];
		$width = empty($options['width']) ? __('150') : $options['width'];
		$height = empty($options['height']) ? __('25') : $options['height'];
		$a = $options['autoplay'] ? '1' : '0';
		if ($a=='1') {
			$player = 'autoPlay=true&audioUrl=' . $audiourl;
		} else {
			$player = 'audioUrl=' . $audiourl;
		}
		echo $before_widget . $before_title . $title . $after_title;
		echo '<script language="javascript">playerobject("'. $player .'", "'. $width .'", "'. $height .'")</script>';
		echo $after_widget;
	}

	function widget_gplayer_control() {
		$options = $newoptions = get_option('widget_gplayer');
		if ( $_POST["gplayer-submit"] ) {
			$newoptions['autoplay'] = isset($_POST['gplayer-autoplay']);
			$newoptions['title'] = strip_tags(stripslashes($_POST["gplayer-title"]));
			$newoptions['audiourl'] = strip_tags(stripslashes($_POST["gplayer-audiourl"]));
			$newoptions['width'] = strip_tags(stripslashes($_POST["gplayer-width"]));
			$newoptions['height'] = strip_tags(stripslashes($_POST["gplayer-height"]));
		}
		if ( $options != $newoptions ) {
			$options = $newoptions;
			update_option('widget_gplayer', $options);
		}
		$title = htmlspecialchars($options['title'], ENT_QUOTES);
		$audiourl = htmlspecialchars($options['audiourl'], ENT_QUOTES);
		$width = htmlspecialchars($options['width'], ENT_QUOTES);
		$height = htmlspecialchars($options['height'], ENT_QUOTES);
		$autoplay = $options['autoplay'] ? 'checked="checked"' : '';
		?>
		<p style="text-align:right;"><label for="gplayer-title"><?php _e('Title:'); ?><input style="width: 200px;" id="gplayer-title" name="gplayer-title" type="text" value="<?php echo $title; ?>" /></label></p>
		<p style="text-align:right;"><label for="gplayer-audiourl"><?php _e('Audio File URL:'); ?><input style="width: 200px;" id="gplayer-audiourl" name="gplayer-audiourl" type="text" value="<?php echo $audiourl; ?>" /></label></p>
		<p style="text-align:right;"><label for="gplayer-width"><?php _e('Width:'); ?><input style="width: 40px;" id="gplayer-width" name="gplayer-width" type="text" value="<?php echo $width; ?>" /></label>
		<label for="gplayer-height"><?php _e('Height:'); ?><input style="width: 40px;" id="gplayer-height" name="gplayer-height" type="text" value="<?php echo $height; ?>" /></label></p>
		<p style="text-align:right;margin-right:40px;"><label for="gplayer-autoplay">Autoplay? <input class="checkbox" type="checkbox" <?php echo $autoplay; ?> id="gplayer-autoplay" name="gplayer-autoplay" /></label></p>
		<input type="hidden" id="gplayer-submit" name="gplayer-submit" value="1" />
		<?php
	}
	register_sidebar_widget(array('Google Player', 'widgets'), 'widget_gplayer');
	register_widget_control(array('Google Player', 'widgets'), 'widget_gplayer_control', 300, 150);
}

function jshead(){
		echo '<script language="javascript" type="text/javascript" SRC="wp-content/plugins/gmailplayer.js"></script>';
	}

add_action('wp_head', 'jshead');
add_action('widgets_init', 'widget_gplayer_init');

function gplayer($title,$audiourl,$width,$height,$a) {
	if ( !function_exists('register_sidebar_widget') ) {
		if ($a=='1') {
			$player = 'autoPlay=true&audioUrl=' . $audiourl;
		} else {
			$player = 'audioUrl=' . $audiourl;
		}
		echo '<script language="javascript">playerobject("'. $player .'", "'. $width .'", "'. $height .'")</script>';
	}
}
?>